
 LST OFF

A_LO EQU $80
A_HI EQU $81

KS_LO EQU $82
KS_HI EQU $83

N_PAKETA EQU $84

HL EQU $85
L EQU $85
H EQU $86

LE_LO EQU $87
LE_HI EQU $88

PRIZNAK EQU $89  ;    (FF/00)

LEN_PAK EQU $8B  ;    (  -)


  ORG $3000

  JMP SA_BLOCK ;  3000 -  SA_BLOCK

ST_BLOCK: DFB 0         ;  3003, 3004 -  
  DFB 0

LN_BLOCK: DFB 0         ;  3005, 3006 -  
  DFB 0                 ; (1 - FFFFH)


;       
SA_BYTE: STA S_BYTE
  LDX #$40     ;    (4 )
  LDY #8
M1SB: LDA #$FF ; CLK = 1
  STA $C080,X
  JSR DEL_CLK  ;  1/2 .   X, Y
  LDA S_BYTE
  AND #1
  STA $C080,X
  JSR DEL_CLK
  ROR S_BYTE
  DEY
  BNE M1SB
  LDA #$FF
  STA $C080,X
  RTS

S_BYTE: DFB 0


;       
READ_BYTE: LDA #0
  STA R_BYTE
  JSR DEL_CLK  ; 
  LDX #$40     ;    (4 )
  LDY #8
M1RB: LDA #$FE ; CLK = 1, DATA = 0 ( )
  STA $C080,X
  JSR DEL_CLK  ;  1/2 .   X, Y
  LDA #0 ; CLK "" (.  0)
  STA $C080,X
  NOP ;    ( IBM  )
  LDA $C082,X ; .    .

  AND #$80
  LSR R_BYTE ;      . 
  ORA R_BYTE
  STA R_BYTE

  JSR DEL_CLK
  DEY
  BNE M1RB
  LDA #$FF
  STA $C080,X
  LDA R_BYTE
  RTS

R_BYTE: DFB 0


;  1/2 .   X, Y,   A.
DEL_CLK: STA $C030
  RTS
  NOP
  NOP ;   JMP  


;      
;    (A5 38 6E 3D)
;        
SA_SYNC: LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #$A5
  JSR SA_BYTE
  LDA #$38
  JSR SA_BYTE
  LDA #$6E
  JSR SA_BYTE
  LDA #$3D
  JSR SA_BYTE
  RTS


;   (LEN_PAK  ) +   (-
;        ) +
; 256*   (LEN_PAK)
; :   (HL) -    256 ;
;          N_PAKETA   
;         LEN_PAK - -    (1-256) 0=256
; :  KS_LO, KS_HI - .  .  . 
AGAT_KS: LDY #0
  STY KS_LO
  LDX #0 ; .  . 
  LDA LEN_PAK
  STA L_PAKETA
KS_1: LDA KS_LO
  CLC
  ADC (HL),Y
  STA KS_LO
  TXA
  ADC (HL),Y
  TAX
  INY
  DEC L_PAKETA
  BNE KS_1
  CLC
  LDA KS_LO
  ADC N_PAKETA
  STA KS_LO
  BCC KS_2
  INX
KS_2: STX KS_HI
  CLC
  LDA LEN_PAK
  ADC KS_HI
  STA KS_HI
  RTS

L_PAKETA: DFB 0


;  . :   (, )
;   ST_BLOCK,  (, ) - LN_BLOCK
SA_BLOCK: LDA ST_BLOCK
  STA A_LO
  LDA ST_BLOCK+1
  STA A_HI
  LDA LN_BLOCK
  STA LE_LO
  LDA LN_BLOCK+1
  STA LE_HI
  LDA #1
  STA N_PAKETA ;   1
  LDA #0
  STA PRIZNAK
  STA LEN_PAK
SB_1: LDA LE_HI
  CMP #0
  BEQ SB_2 ;   
  CMP #1
  BNE SB_3
  LDA LE_LO
  CMP #0
  BEQ SB_2
SB_3: JSR SA_PAKET
  INC A_HI
  DEC LE_HI
  INC N_PAKETA
  JMP SB_1

;  
SB_2: LDA #$FF ;   
  STA PRIZNAK
  LDA LE_LO ;   (0  100H)
  STA LEN_PAK
  JSR SA_PAKET
  RTS


;  . :   (, )
;   A_LO, A_HI;   (1 - 00) - N_PAKETA;
;    (FF/00) - PRIZNAK
; LEN_PAK -   (1 - 00)
SA_PAKET: LDA A_LO
  STA L
  LDA A_HI
  STA H
  JSR AGAT_KS ;   

SP_0: JSR SA_SYNC
  LDA N_PAKETA
  JSR SA_BYTE
  LDA PRIZNAK
  JSR SA_BYTE
  LDA LEN_PAK
  STA L_PAKETA
  JSR SA_BYTE

  LDY #0
SP_1: TYA
  PHA
  LDA (A_LO),Y
  JSR SA_BYTE
  PLA
  TAY
  INY
  DEC L_PAKETA
  BNE SP_1

  LDA KS_LO ;   
  JSR SA_BYTE
  LDA KS_HI ;  
  JSR SA_BYTE

  LDA #0    ; 5   
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE
  LDA #0
  JSR SA_BYTE

  JSR READ_BYTE
  PHA

  LDA #0      ;  1       
  JSR SA_BYTE

  PLA
  CMP #$E6
  BNE SP_0

  RTS
 